#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;

bool palindrom(string s){
    int i=0, j=s.size()-1;
    while(i <= j){
        if(i != j)return false;
        i++; j--;
    }
    return true;
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n,q; cin >> n >> q;
    vector<vector<pair<int, char>>> adj(n);
    while(q--){
        int t; cin >> t;
        int u,v; cin >> u >> v;
        u--; v--;
        if(t==1){
            char c; cin >> c;
            adj[u].emplace_back(v,c);
            adj[v].emplace_back(u,c);
        }
        else {
            cout << 1 << '\n';
            dun:;
        }
    }
    return 0;
}